function calcRoll(lblHeight, lblWidth, prefs){

	document.getElementById("lblHeight").value = lblHeight;
	document.getElementById("lblWidth").value = lblWidth;
	document.getElementById("dCalcRoll").innerHTML = "";
	if ((+lblWidth > 0)&&(+lblHeight > 0)){	

		var	rowDiv = document.getElementById('dCalcRoll').appendChild(document.createElement("div"));
			rowDiv.className = "row";
		var	col1Div = rowDiv.appendChild(webWidth(lblWidth, 0, prefs));
		var	col2Div = rowDiv.appendChild(webWidth(lblHeight, 1, prefs));
		if (document.getElementById('chkFlat').checked){
			rowDiv = document.getElementById('dCalcRoll').appendChild(document.createElement("div"));
			rowDiv.className = "row";
			col1Div = rowDiv.appendChild(document.createElement("div"));
			col1Div.className = "col";
			col1Div.appendChild(buttonCreate(lblHeight, lblWidth, 0));
			col2Div = rowDiv.appendChild(document.createElement("div"));
			col2Div.className = "col";
			col2Div.appendChild(buttonCreate(lblWidth, lblHeight, 1));
		}
		else{
			rowDiv = document.getElementById('dCalcRoll').appendChild(document.createElement("div"));
			rowDiv.className = "row";
			col1Div = rowDiv.appendChild(document.createElement("div"));
			col1Div.className = "col";
			col1Div.appendChild(calcTab(lblHeight, lblWidth, 0, prefs));
			col2Div = rowDiv.appendChild(document.createElement("div"));
			col2Div.className = "col";
			col2Div.appendChild(calcTab(lblWidth, lblHeight, 1, prefs));
			
			$("#tab0").tablesorter({sortList: [[prefs.tabSortDef,0], [1,0]]}); 
			$("#tab1").tablesorter({sortList: [[prefs.tabSortDef,0], [1,0]]}); 
		}
		rowDiv = document.getElementById('dCalcRoll').appendChild(document.createElement("div"));
		rowDiv.className = "row";
		col1Div = rowDiv.appendChild(document.createElement("div"));
		col1Div.className = "col";
		col1Div.appendChild(draw_svg(+lblWidth, +lblHeight));
		col2Div = rowDiv.appendChild(document.createElement("div"));
		col2Div.className = "col";
		col2Div.appendChild(draw_svg(+lblHeight, +lblWidth));
	}
}
function buttonCreate(lblHeight, lblWidth, rotate){
	var labels = 0;
	var betLbl = document.getElementById("betLabels").value;
	var rollItem = "000";
	var raport = 0;
	var	but = document.createElement("input");
		but.type = "button";
		but.className = "hostButton";
		but.value = "Чертеж";
		but.setAttribute ("onclick","Draw("+ "document.getElementById('" + "rows" + rotate + "').value, " + labels + ", " + betLbl + ", '" + rollItem + "', " + raport + ", " + rotate + ");")
	return but;
}
function webWidth(lblWidth, rotate, prefs){
	var betRows = document.getElementById("betRows").value;
	var rows = Math.floor((prefs.webWidthMax - prefs.reilWidth)/(1 * lblWidth + 1 * betRows));
	if (rows > prefs.rowsMax) rows = prefs.rowsMax;

	var webDiv = document.createElement("div");
		webDiv.className = "colWeb";
		var rowDiv = webDiv.appendChild(document.createElement("div"));
			rowDiv.className = "row";
		var	colDiv = rowDiv.appendChild(document.createElement("div"));
			colDiv.className = "col";
		var paragr = colDiv.appendChild(document.createElement("P"));
			paragr.innerHTML = "Ручьев";
			colDiv = rowDiv.appendChild(document.createElement("div"));
			colDiv.className = "col";
			paragr = colDiv.appendChild(document.createElement("P"));
			paragr.innerHTML = "Ширина материала";
			rowDiv = webDiv.appendChild(document.createElement("div"));
			rowDiv.className = "row";
			colDiv = rowDiv.appendChild(document.createElement("div"));
			colDiv.className = "col";
		var input = colDiv.appendChild(document.createElement("input"));
			input.className = "input";
			input.width = "inherit";
			input.type = "number";
			input.id = "rows" + rotate;
			input.value = rows;
			input.min = "1";
			input.max = "100";
			input.setAttribute("onclick","document.getElementById('webWidth" + rotate + "').value = calcWebWidth(" + lblWidth + ", document.getElementById('rows" + rotate + "').value);");
			colDiv = rowDiv.appendChild(document.createElement("div"));
			colDiv.className = "col";
			input = colDiv.appendChild(document.createElement("input"));
			input.id = "webWidth" + rotate;
			input.className = "input";
			input.readOnly = true;
			input.value = calcWebWidth(lblWidth, rows);
			
	return webDiv;
}
function calcWebWidth(lblWidth, rows){
	var betRows = document.getElementById("betRows").value;
	return Math.floor(Number(rows) * (Number(lblWidth) + Number(betRows)) - Number(betRows) + 6);
}
function calcTab(lblHeight, lblWidth, rotate, prefs){
	var rolls = prefs.rolls;
	var betLbl;
	var betLblMin = +document.getElementById("betLabels").value;
	var min = 500;
	console.log(rolls);

	rolls.forEach(function(rollItem, i) {
		var item = rollItem.toString().split('-');
		var raport;
		if (item.length == 1){
			raport = item[0] * 3.175;
		}
		else{
			raport = item[0] * item[1];
		}
		var labels = Math.floor(raport / (+lblHeight + betLblMin));
		if (labels != 0){
			betLbl = ((raport - (labels * lblHeight))/labels).toFixed(3);
			if (+min > +betLbl) {min = betLbl;}
		} 
	});

	var	newTab = document.createElement("table");
		//newTab.width="225";
		newTab.className="cat";
		newTab.id = "tab" + rotate;
			
	rolls.forEach(function(rollItem, i) {
		var item = rollItem.toString().split('-');
		if (item.length == 1){
			raport = item[0] * 3.175;
		}
		else{
			raport = item[0] * item[1];
		}
		var labels = Math.floor(raport / (+lblHeight + betLblMin));
		if (labels != 0){betLbl = ((raport - (labels * lblHeight))/labels).toFixed(3);} 
		else {betLbl = 0;}
		
		newRow = newTab.insertRow(-1);
		newRow.setAttribute ("onclick","Draw("+ "document.getElementById('" + "rows" + rotate + "').value," + labels + "," + betLbl + "," + rollItem + "," + raport + "," + rotate + ");")
		if (min == betLbl){
			//newRow.setAttribute("bgcolor","#ffd2d2")
			newRow.className="cat catmin";
		}
		newCell = newRow.insertCell();
		newCell.innerHTML = rollItem;
		newCell = newRow.insertCell();
		newCell.innerHTML = new Intl.NumberFormat("en-EN", {minimumFractionDigits : 3}).format(raport);
		newCell = newRow.insertCell();
		newCell.innerHTML = labels;
		newCell = newRow.insertCell();
		newCell.innerHTML = new Intl.NumberFormat("en-EN", {minimumFractionDigits : 3}).format(betLbl);
		newCell.setAttribute("width", '30%');
	});
		newTH = newTab.createTHead();
	var newRow = newTH.insertRow(0);
	var newCell = newRow.insertCell();
		newCell.innerHTML = "Вал";
		newCell = newRow.insertCell();
		newCell.innerHTML = "Раппорт";
		newCell = newRow.insertCell();
		newCell.innerHTML = "Этикеток";
		newCell = newRow.insertCell();
		newCell.innerHTML = "Между этикетками";
	return newTab;
}
function draw_svg (stW, stH){
	var idt = 10;
	var wArr = 20;
	var dArr = 20;

	var cW = 230;
	var cH = 230 - wArr;

	var w, h;

	if (stW > stH){
		h = stH / stW * (cH - (idt * 2 + dArr));
		w = cW - (idt * 2 + wArr + dArr);
	}
	else {
		h = cH - (idt * 2 + dArr);
		w = stW / stH * (cW - (idt * 2 + wArr + dArr));
	}

	var sY = (cH - idt * 2 - h) / 2 - dArr;
	if (sY < 0) sY = 0;
	var sX = (cW - idt * 2 - wArr - dArr - w) / 2;
	if (sX < 0) sX = 0;

	var mySvg = document.createElementNS("http://www.w3.org/2000/svg", "svg");
		mySvg.setAttribute("width", cW);
		mySvg.setAttribute("height", cH);
		mySvg.setAttribute("class","svg-canvas");
	var rect  = document.createElementNS("http://www.w3.org/2000/svg", "rect");
		rect.setAttribute("x", 0);
		rect.setAttribute("y", 0);
		rect.setAttribute("width", cW);
		rect.setAttribute("height", cH);
		rect.setAttribute("rx", "0");
		rect.setAttribute("stroke-width", "1px");
		mySvg.appendChild(rect);

	var line  = document.createElementNS("http://www.w3.org/2000/svg", "path");
		line.setAttribute("d", "M " + (idt + wArr - 10) + " " + (cH - idt) + " " + (idt + wArr - 10) + " " + idt + " " + (idt + wArr - 7) + " " + (idt + 10) + " " + (idt + wArr - 13) + " " + (idt + 10) + " " + (idt + wArr - 10) + " " + idt + "z");
		line.setAttribute("class","svg-path");
		line.setAttribute("stroke-width", "1.5px");
		mySvg.appendChild(line);
		
	var txt  = document.createElementNS("http://www.w3.org/2000/svg", "text");	
		txt.innerHTML = "Направление печати";
		txt.setAttribute("x", idt + wArr - 15);
		txt.setAttribute("y", cH / 2);
		txt.setAttribute("class","svg-text");
		txt.setAttribute("font-family", "Arial");
		txt.setAttribute("font-weight", "bold");
		txt.setAttribute("text-anchor", "middle");
		txt.setAttribute("font-size", "10");
		txt.setAttribute("transform", "rotate(-90, " + (idt + wArr - 15) + " " + (cH / 2)+")");
		mySvg.appendChild(txt);
		
	var rect  = document.createElementNS("http://www.w3.org/2000/svg", "rect");
		rect.setAttribute("x", wArr + dArr + idt + sX);
		rect.setAttribute("y", idt + dArr + sY);
		rect.setAttribute("width", w);
		rect.setAttribute("height", h);
		rect.setAttribute("rx", "4");
		rect.setAttribute("class","svg-rect");
		rect.setAttribute("stroke-width", "1.5px");
		mySvg.appendChild(rect);
		// ширина
	var line  = document.createElementNS("http://www.w3.org/2000/svg", "path");
		line.setAttribute("d", "M " + (wArr + dArr + idt + sX) + " " + (idt + dArr - 10 + sY) + " "  + (w + wArr + dArr + idt + sX) + " " +  (idt + dArr - 10 + sY));
		line.setAttribute("stroke-width", "1px");
		line.setAttribute("class","svg-path");
		mySvg.appendChild(line);
		
	var line  = document.createElementNS("http://www.w3.org/2000/svg", "polyline");
		line.setAttribute("points", (wArr + dArr + idt + sX) + "," + (idt + 10 + sY) + " "  + (wArr + dArr + idt + 10 + sX) + "," + (idt + 13 + sY) + " " + (wArr + dArr + idt + 10 + sX) + "," + (idt + 7 + sY));
		line.setAttribute("stroke-width", "0px");
		line.setAttribute("class","svg-path");
		mySvg.appendChild(line);

	var line  = document.createElementNS("http://www.w3.org/2000/svg", "polyline");
		line.setAttribute("points", (wArr + dArr + idt + w + sX)  + "," + (idt + 10 + sY) + " "  + (wArr + dArr + idt + w - 10 + sX) + "," + (idt + 13 + sY) + " " + (wArr + dArr + idt + w - 10 + sX) + "," + (idt + 7 + sY));
		line.setAttribute("stroke-width", "0px");
		line.setAttribute("class","svg-path");
		mySvg.appendChild(line);
		
	var txt  = document.createElementNS("http://www.w3.org/2000/svg", "text");	
		txt.innerHTML = new Intl.NumberFormat("en-EN", {minimumFractionDigits : 3}).format(stW);
		txt.setAttribute("x", w/2 + wArr + dArr + idt + sX);
		txt.setAttribute("y", idt + dArr - 15 + sY);
		txt.setAttribute("class","svg-text");
		txt.setAttribute("font-family", "Arial");
		txt.setAttribute("font-weight", "bold");
		txt.setAttribute("text-anchor", "middle");
		txt.setAttribute("font-size", "10");
		mySvg.appendChild(txt);
		
		// длина
	var line  = document.createElementNS("http://www.w3.org/2000/svg", "path");
		line.setAttribute("d", "M " + (wArr + idt + dArr - 10 + sX) + " " + (idt + dArr + sY) + " "  + (wArr + idt + dArr - 10 + sX) +" " + (idt + dArr + h + sY));
		line.setAttribute("stroke-width", "1px");
		line.setAttribute("class","svg-path");
		mySvg.appendChild(line);
		
	var line  = document.createElementNS("http://www.w3.org/2000/svg", "polyline");
		line.setAttribute("points", (wArr + idt + dArr - 10 + sX) + "," + (idt + dArr + sY) + " "  + (wArr + idt + dArr - 7 + sX) + "," + (idt + dArr + 10 + sY) + " " + (wArr + idt + dArr - 13 + sX) + "," + (idt + dArr + 10 + sY));
		line.setAttribute("stroke-width", "0px");
		line.setAttribute("class","svg-path");
		mySvg.appendChild(line);

	var line  = document.createElementNS("http://www.w3.org/2000/svg", "polyline");
		line.setAttribute("points", (wArr + idt + dArr - 10 + sX) + "," + (idt + dArr + h + sY) + " "  + (wArr + idt + dArr - 7 + sX) + "," + (idt + dArr + h - 10 + sY) + " " + (wArr + idt + dArr - 13 + sX) + "," + (idt + dArr + h - 10 + sY));
		line.setAttribute("stroke-width", "0px");
		line.setAttribute("class","svg-path");
		mySvg.appendChild(line);
		
	var txt  = document.createElementNS("http://www.w3.org/2000/svg", "text");	
		txt.innerHTML = new Intl.NumberFormat("en-EN", {minimumFractionDigits : 3}).format(stH);
		txt.setAttribute("x", wArr + idt + dArr - 15 + sX);
		txt.setAttribute("y", (h / 2 + idt + dArr + sY));
		txt.setAttribute("class","svg-text");
		txt.setAttribute("font-family", "Arial");
		txt.setAttribute("font-weight", "bold");
		txt.setAttribute("text-anchor", "middle");
		txt.setAttribute("font-size", "10");
		txt.setAttribute("transform", "rotate(-90, " + (wArr + idt + dArr - 15 + sX) + " " + (h / 2 + idt + dArr + sY)+")");
		mySvg.appendChild(txt);
		
		return(mySvg);
}